# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/hibernate-annotations/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirres %{repodir}/resources
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA_CP04
%define hname hibernate-annotations
%define namedversion %{version}.%{reltag}

Summary:        Relational persistence and query service
Name:           hibernate3-annotations
Version:        3.4.0
Release:        3.3.%{reltag}%{?dist}
Epoch:          0
License:        LGPL
URL:            http://annotations.hibernate.org/
Group:          Database
Source0:        hibernate-annotations-3.4.0.%{reltag}-src.tar.gz
Source1:		%{hname}-jpp-depmap.xml
Source2:		%{hname}-component-info.xml

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven-injection-plugin
BuildRequires:  maven-test-ext-plugin
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-release
BuildRequires:  maven-surefire
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-doxia-sitetools
BuildRequires:  junit >= 3.8.2
BuildRequires:  hsqldb
BuildRequires:  slf4j >= 0:1.5.6
BuildRequires:  hibernate3-commons-annotations >= 3.1.0
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 0:3.4.0
BuildRequires:  hibernate3 >= 0:3.3.2
BuildRequires:  antlr >= 0:2.7.6
BuildRequires:  objectweb-asm >= 3.1
BuildRequires:  jakarta-commons-collections >= 0:3.1
BuildRequires:  javassist >= 0:3.9.0
BuildRequires:  jboss-transaction-1.0.1-api 
BuildRequires:  log4j >= 1.2.14
BuildRequires:	jboss-parent

Requires:  java >= 0:1.5
Requires:  hibernate3 >= 0:3.3.2
Requires:  hibernate3-ejb-persistence-3.0-api >= 0:3.4.0
Requires:  hibernate3-commons-annotations >= 3.1.0
#Requires:  hibernate3-validator >= 0:3.0.0

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Hibernate, like all other object/relational mapping tools, 
requires metadata that governs the transformation of data 
from one representation to the other (and vice versa). In 
Hibernate 2.x, mapping metadata is most of the time declared 
in XML text files. Another option is XDoclet, utilizing 
Javadoc source code annotations and a preprocessor at compile 
time.
The same kind of annotation support is now available in the 
standard JDK, although more powerful and better supported by 
tools. IntelliJ IDEA, for example, supports auto-completion 
and syntax highlighting of JDK 5.0 annotations. The EJB3 
specification standardizes the basic APIs and the metadata 
(using JDK 5.0 annotations) needed for any object/relational 
persistence mechanism. Hibernate EntityManager for EJB3 
implements the programming interfaces and lifecycle rules as 
defined by the EJB3 persistence specification. Both Hibernate 
EntityManager and Hibernate Annotations are available in 
standalone preview releases, however, they require Hibernate 
3.1 and JDK 5.0. If you are not using EJB3 persistence, 
please continue using Hibernate 3.0.x (with any JDK supported).
The Hibernate Annotations package provides annotations for
Standard JSR-220 defined O/R mapping
Hibernate O/R mapping extensions
Data validation via the Hibernate Validator framework

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	         Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package zip
Summary:        Zip distrubution for %{name}
Group:          Development

%description zip
Zip distribution for %{name}.

%prep
%setup -q -n %{hname}

%build

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p target/%{hname}-%{version}.%{reltag}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p target/%{hname}-%{version}.%{reltag}-sources.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{hname}-sources.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|%{name}|%{hname}|g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
#(cd $RPM_BUILD_ROOT%{_javadocdir} && for doc in *-%{version}; do ln -sf ${doc} `echo $doc| sed "s|%{name}|%{hname}|g"`; done)
#(cd $RPM_BUILD_ROOT%{_javadocdir} && for doc in *-%{version}; do ln -sf ${doc} `echo $doc| sed "s|-%{version}||g"`; done)
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

#pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%add_to_maven_depmap org.hibernate %{hname} %{namedversion} JPP %{name}
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
	cp $RPM_BUILD_ROOT%{_javadir}/%{hname}.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/%{hname}-sources.jar $RPM_BUILD_ROOT%{repodirlib} 	
	cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/hibernate-annotations.pom
%endif

# Dist
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/hibernate3-annotations-fordev
cp target/hibernate-annotations*.zip $RPM_BUILD_ROOT%{_javadir}/hibernate3-annotations-fordev/hibernate-annotations.zip

# License
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
#%{_datadir}/%{name}-%{version}
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%files zip
%defattr(0644,root,root,0755)
%{_javadir}/hibernate3-annotations-fordev/*.zip

%changelog
* Sat Feb 12 2011 Strong Liu <stliu@redhat.com> = 0:3.4.0-3.3.GA_CP04
- Upgrade to 3.4.0.GA_CP04
- Remove upgrade-core.patch

* Fri Feb 11 2011 Strong Liu <stliu@redhat.com> = 0:3.4.0-3.2.GA_CP03
- Add hibernate-core 3.3.2.GA_CP04 to c-i.xml
- Apply patch to correct encoding error

* Sat Jul 24 2010 Strong Liu <stliu@redhat.com> = 0:3.4.0-3.1.GA_CP03
- Upgrade to 3.4.0.GA_CP03
- Remove BR jta_1_1_api
- Add BR jboss-transaction-1.0.1-api

* Thu Jun 03 2010 Strong Liu <stliu@redhat.com> = 0:3.4.0-3.0.GA_CP02
- Correct Release Number

* Tue May 25 2010 Strong Liu <stliu@redhat.com> = 0:3.4.0-1.4.GA_CP02
- Correct tag version in component-info.xml

* Fri May 21 2010 Strong Liu <stliu@redhat.com> = 0:3.4.0-1.3.GA_CP02
- Correct compatible file

* Fri May 21 2010 Strong Liu <stliu@redhat.com> = 0:3.4.0-1.2.GA_CP02
- Update source tarball of 3.4.0.GA_CP02

* Wed May 19 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.1.GA_CP02
- Add dist package

* Wed May 19 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.0.GA_CP02
- Upgrade to 3.4.0.GA_CP02

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> - 0:3.4.0-2.1.GA_CP01
- Rebuild

* Fri Jan 29 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-2.0.GA_CP01
- Add pom to repolib

* Fri Jan 22 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.9.GA_CP01
- Rebuild in brew

* Thu Jan 21 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.8.GA_CP01
- Remove java doc zip
- Update patch to remove javadoc offline section

* Wed Jan 20 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.7.GA_CP01
- Rebuild to use the new source tarball
* Sun Jan 17 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.6.GA_CP01
- Update release tag to rebuild in brew
* Sat Jan 16 2010 Strong Liu <stliu@redhat.com> - 0:3.4.0-1.5.GA_CP01
- Update release tag to include GA_CP01
* Thu Jan 14 2010 Strong Liu <stliu@redhat.com>  - 0:3.4.0-1.4
- Enable maven2-plugin-source plugin
- Clean the source tarball, remove svn metadata file

* Thu Jan 14 2010 Strong Liu <stliu@redhat.com>  - 0:3.4.0-1.3
- Upgrade Hibernate Annotations to 3.4.0.GA_CP01
- Rremove hibernate3-serializableToBlobType.java.patch
- Update hibernate-annotations-component-info.xml, this version of Annotation does not compatible with Core 3.3.2.GA, but 3.3.2.GA_CP01
- Update hibernate-annotations-pom.xml.patch

* Mon Jul 20 2009 Strong Liu <stliu@redhat.com>  - 0:3.4.0-1.2
- Change the source jars name to *-sources.jar
- Update copyrights to 2009
* Sun Jul 19 2009 Gail Badner <gbadner@redhat.com> - 0:3.4.0-1.1
- First release for RHEL-4-EP-5
